Subject: Re: bug#24206: 25.1; Curly quotes generate invalid strings, leading to a segfault

From: Eli Zaretskii <[email-masked]>
Date: Wed, 17 Aug 2016 21:06:42 +0300

> Cc: [email-masked], [email-masked]
> From: Paul Eggert <[email-masked]>
> Date: Wed, 17 Aug 2016 10:41:52 -0700
> 
> >   -	  if (multibyte)
> >   -	    {
> >   -	      int len;
> >   -
> >   -	      STRING_CHAR_AND_LENGTH (strp, len);
> >   -	      if (len == 1)
> >   -		*bufp = *strp;
> >   -	      else
> >   -		memcpy (bufp, strp, len);
> >   -	      strp += len;
> >   -	      bufp += len;
> >   -	      nchars++;
> >   -	    }
> >   -	  else
> >   -	    *bufp++ = *strp++, nchars++;
> >   +	  /* Fall through to copy one char.  */
> 
> Some change in this area was needed because the 'multibyte' flag went away. 

Only because you removed it.  You could have left it alone, it would
have worked even after the call to Fstring_make_multibyte, for the
reasons I explained earlier: the result is not necessarily a multibyte
string.

> While doing that, I noticed that discarding all the code made this 
> somewhat-tricky area easier to follow. It's not merely that the old multibyte 
> code is unnecessarily long and hard to follow; it's that the old code does 
> something fairly-typical (copy a multibyte character) in an unusual way, which 
> is too likely to lead the reader into incorrectly thinking that there is 
> something actually unusual about the action. Misleading code like this really 
> cries out to be rewritten, particularly if the rewriting simply ionvolves 
> deleting it.

I don't see why it is tricky, we do that in Emacs in other places.
It's pretty boilerplate.

> In short, the main motivation here was clarity, not merely style.

That's exactly my point: it's more clear for you, but that alone is
not reason good enough to make such changes in code that worked for
many years.

> (I hope I don't have to go into such details to defend every code change I 
> install! I'm finding it difficult-enough now to find time to improve Emacs.)

I could simply revert your commit, it would have saved us both quite
some time.  Would you prefer that?

> This one is not merely a style change. The old code matched \[ even if not 
> followed by ], the new code does not. This is an intended improvement. I plead 
> guilty to the charge that the new code is also shorter and clearer.

Then why is there nothing about this in the log entry?

> >   -	  /* Note the Fwhere_is_internal can GC, so we have to take
> >   -	     relocation of string contents into account.  */
> >   -	  strp = SDATA (string) + idx;
> >   -	  start = SDATA (string) + start_idx;
> >   +	  /* Take relocation of string contents into account.  */
> >   +	  strp = SDATA (str) + idx;
> >   +	  start = strp - length_byte - 1;
> 
> The new comment came because I copied it from somewhere else in the interest of 
> consistency. You're right, I omitted some commentary in the process. I thought 
> the omitted info obvious, but evidently you think otherwise. It's obviously no 
> big deal, so I brought it back by applying the attached patch to master.

Thanks.

> > Unlike at that time, I now think
> > this was a bad move, because Emacs 25.1 will have the disabled
> > conversion in it, so by the time we release the code in master, it
> > would be an incompatible change.
> 
> If that's the main objection, then let's change Emacs 25 to behave similarly. 
> This would be a simple and conservative change to Emacs 25. But even if you 
> don't want to change Emacs 25 (and thus you want to Emacs 25 to continue to be 
> less-compatible with Emacs 24), it's OK to change this minor detail back to the 
> way Emacs 24 does things.

Alas, it's too late to change Emacs 25.1.

> > (I also don't see how it is related to the
> > original bug report, which AFAIU was about (message "`foo'") that
> > still behaves as in the bug report.)
> 
> Alan wanted something that he could put into his .emacs that would cause 
> (message PERCENTLESS) to output the string PERCENTLESS as-is, assuming 
> PERCENTLESS lacks %. This was the point of his original bug report; his original 
> example involved ` and ' but he wanted the same behavior for ‘ and ’, a point 
> that became clear during the discussion of Bug#23425.

Then why not for '..' as well?  How is that different from ‘..’?  What
we have now on master is inconsistent and cannot be defended, IMO.

> > (Mumbles something about Emacs maintenance being a lonely business...)
> 
> But we have all these nice conversations! :-)

Oh yes, what a relief!